(*
  Pklad pouit komunikan knihovny CommIntfDll.dll pomoc objektu TUserCommunicationInterface.
  Vytvoeno pro Delphi 7

  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
  Autor     :  Martin Zmenk zamecnik@papouch.com

  Poznmky  : k pouit funkc je poteba knihovna CommIntfDll.dll, unita mapujc funkce uci_IDLLMapD.pas a unita pro zaobalen do objektu uUserInterface.
              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll, nebo nainstalovan virtuln sriov port

*)
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,uUserInterface, ComCtrls, ExtCtrls;

type
  TfCommDllSample = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    ConnectionString: TComboBox;
    cmdCreate: TButton;
    cmdOpenClose: TButton;
    cmdDlg: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox3: TGroupBox;
    chSendHex: TCheckBox;
    mSend: TMemo;
    cmdSend: TButton;
    GroupBox2: TGroupBox;
    cmdClear: TButton;
    chRcvHex: TCheckBox;
    mRcv: TMemo;
    GroupBox4: TGroupBox;
    leAddress: TLabeledEdit;
    leSig: TLabeledEdit;
    Panel2: TPanel;
    Label4: TLabel;
    cmdClearSnd: TButton;
    cbInst: TComboBox;
    Label2: TLabel;
    mSDSnd: TMemo;
    Label3: TLabel;
    chSpinSendHex: TCheckBox;
    cmdSPSend: TButton;
    GroupBox5: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    chSpinRcvHex: TCheckBox;
    leAdrR: TLabeledEdit;
    leSigR: TLabeledEdit;
    mSDRcv: TMemo;
    cmdSPClear: TButton;
    eAck: TEdit;
    procedure cmdCreateClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdClearClick(Sender: TObject);
    procedure cmdSendClick(Sender: TObject);
    procedure cmdClearSndClick(Sender: TObject);
    procedure cmdOpenCloseClick(Sender: TObject);
    procedure cmdDlgClick(Sender: TObject);
    procedure cmdSPClearClick(Sender: TObject);
    procedure cmdSPSendClick(Sender: TObject);
  private
    CommIntf:TUserCommunicationInterface; //Objekt komunikanho rozhran
    procedure OnOpen(sender:TObject); //Procedura vyvolan pi udlosti oteven komunikanho kanlu
    procedure OnClose(sender:TObject); //Procedura se vyvol pi udlosti zaven komunikanho kanlu
    procedure OnDataRcv(sender:TObject); //Procedura se vyvol pi udlosti pijet dat
    procedure ActiveChange(Active:boolean); //Uprav tlatka na formuli podle toho, zda je spojen oteveno i zaveno
  public
  end;

var
  fCommDllSample: TfCommDllSample;

implementation

{$R *.dfm}

//funkce, kter data zapsan v hexa (FA 12 A6) pevede na odpovdajc data
function HexToText(const Hex:string):string;
var s:string;
    i:integer;
begin
  S:=StringReplace(Hex,' ','',[rfReplaceAll]);
  S:=StringReplace(S,#13,'',[rfReplaceAll]);
  S:=StringReplace(S,#10,'',[rfReplaceAll]);
  //-- odstranny mezery a entery
  result:='';
  for i:=0 to length(S) div 2 - 1 do
  begin
    result:=result+chr(strtoint('$'+copy(S,i*2+1,2)));
  end;
end;
//funkce, kter data peveda na hexa zpis
function TextToHex(const Text:string):string;
var i:integer;
begin
  result:='';
  for i:=1 to length(Text) do
  begin
    result := result + IntToHex(ord(Text[i]),2) + ' ';
  end;
end;
//zmn netisknuteln znaky na teky
function TextToPrintable(const Text:string):string;
var I:integer;
begin
  result:=Text;
  for i:=1 to length(Text) do
  begin
    if ((result[i]<#32)or(result[i]>=#127)) then result[i]:='.';
  end;
end;
//-------------------------------------
procedure TfCommDllSample.ActiveChange(Active: boolean);
begin
  //Zaktivn i zneaktivn tlatka pro odesln dat
  cmdSend.Enabled := Active;
  cmdSPSend.Enabled := Active;
  //Zmn popisek tlata
  if Active
    then cmdOpenClose.Caption := 'Zavt'
    else cmdOpenClose.Caption := 'Otevt';
end;

procedure TfCommDllSample.cmdCreateClick(Sender: TObject);
begin

  //Zru stvajc komunikan rozhran, pokud je vytvoeno
  if assigned(CommIntf) then
  begin
    FreeAndNil(CommIntf); //Zru rozhran
    ActiveChange(false);  //Nastav tlatka na formuli
  end;

  CommIntf:=TUserCommunicationInterface.Create(ConnectionString.Text);
  //-Vytvo komunikan rozhran podle pipojovacho etzce

  if assigned(CommIntf) then //-- pokud se podailo vytvoit
  begin
    //-- namapovn udlost komunikanho rozhran (oteven a zaven komunikace, pjem dat)
    CommIntf.OnOpen := OnOpen;
    CommIntf.OnClose := OnClose;
    CommIntf.OnDataRcv := OnDataRcv;
    if MessageDlg('Bylo vytvoeno komunikan rozhran. Chcete ho otevt?',mtInformation,[mbYes,mbNo],0)=IDYES
      then CommIntf.Open; //-- oteven komunikace
  end;

end;

procedure TfCommDllSample.FormDestroy(Sender: TObject);
begin
 //Pi ukonen se zru komunikan rozhran, pokud je vytvoeno
 if assigned(CommIntf)
   then CommIntf.Free;
end;

procedure TfCommDllSample.OnClose(sender: TObject);
begin
  ActiveChange(false); //Uprav tlatka na formuli (zneaktivn tlatka pro odesln dat, npis na tlatku pro oteven nastav na "otevt")
end;

procedure TfCommDllSample.OnDataRcv(sender: TObject);
var S:string;
begin
  if sender is TUserCommunicationInterface then
  begin
     S:=(sender as TUserCommunicationInterface).ReadString; //!!!Naten pijatch dat
     if chRcvHex.Checked //Pokud je zakrtl zobrazovat v hexa ...
        then mRcv.Lines.Add(TextToHex(S)) // ... pevedou se pijat data do hexa formtu a zobraz ...
        else mRcv.Lines.Add(TextToPrintable(S)); // ... jinak se zobraz pmo, netisknuteln znaky se pevedou na teky
  end;
end;

procedure TfCommDllSample.OnOpen(sender: TObject);
begin
  ActiveChange(true); //Uprav tlatka na formuli (zaktivn tlatka pro odesln dat, npis na tlatku otevt zmn na zavt)
end;

procedure TfCommDllSample.FormCreate(Sender: TObject);
begin
  ActiveChange(false);
  //Uprav tlatka na formuli (zneaktivn tlatka pro odesln dat, npis na tlatku pro oteven nastav na "otevt")
end;

procedure TfCommDllSample.cmdClearClick(Sender: TObject);
begin
  mRcv.Clear; //vymae pijat data
end;

procedure TfCommDllSample.cmdSendClick(Sender: TObject);
begin
 //Odele zadan data
 if chSendHex.Checked  //Pokud je zakrtl zadvn v hexa ...
   then CommIntf.WriteString(HexToText(mSend.Text)) //... pevedou se data z hexa ...
   else CommIntf.WriteString(mSend.Text); // ... jinak se odele prost text jako data
end;

procedure TfCommDllSample.cmdClearSndClick(Sender: TObject);
begin
  mSend.Clear; //Vymae data pro odesln
end;

procedure TfCommDllSample.cmdOpenCloseClick(Sender: TObject);
begin
  if assigned(CommIntf) then //Rozhran mus bt vytvoeno ...
  begin
    CommIntf.Active := not CommIntf.Active; //Pokud bylo spojen oteveno tak se zave, v opanm ppad se oteve
  end else ShowMessage('Nejprve je komunikan rozhran teba vytvoit.'); //... pokud nen vytvoeno - upozornn
end;

procedure TfCommDllSample.cmdDlgClick(Sender: TObject);
var S:string;
begin
  //Uprav se pipojovac etzec pomoc dialogu

  S:=ConnectionString.Text; //pvodn pipojovac etzec
  if TUserCommunicationInterface.ConnectionStringDlg(S) then
  begin //Pokud bylo v dialogu stisknuto OK
    ConnectionString.Text := S; //Zmn se pipojovac etzec podle dialogu

    //Nabdne se rovnou rozhran podle komunikanho etzce vytvoit
    if MessageDlg('Chcete rovnou komunikan spojen vytvoit?',mtConfirmation,[mbYes,mbNo],0)=IDYES then
    begin
      cmdCreateClick(cmdCreate);
    end;
  end;
  
end;

procedure TfCommDllSample.cmdSPClearClick(Sender: TObject);
begin
  //Vymae zobrazen pijatho spinel paketu
  eAck.Text := '';
  leAdrR.Text := '';
  leSigR.Text := '';
  mSDRcv.Text := '';
end;

procedure TfCommDllSample.cmdSPSendClick(Sender: TObject);
var Data:string;
    Adr,Sig,Inst_Ack:byte;
begin
  //Odele se zadan spinel paket a pijme se odpov

  //Nastaven dat :
  if chSpinSendHex.Checked //pokud je zakrtnuto zadvn dat v hexa ...
    then Data:=HexToText(mSDSnd.Text) //...pevede se z hexa...
    else Data:=mSDSnd.Text; //...jinak se bere prost text

  Adr:=StrToInt(leAddress.Text); //Nasteven adresy

  Sig := StrToInt(leSig.Text); //Nastaven podpisu

  //Nastaven instrukce:
  if pos(';',cbInst.Text)>0 //Pokud kd instrukce obsahuje koment ( za stednkem)...
    then Inst_Ack:=StrToInt(trim(Copy(cbInst.Text,1,pos(';',cbInst.Text)-1))) //... hledme instrukci ped stednkem ...
    else Inst_Ack:= StrToInt(cbInst.Text); //... jinak v celm obsahu

  if CommIntf.SndRcvSpin97(Adr,Sig,Inst_Ack,Data) then //!!!Odeleme paket a ekme na odpov
  begin //pokud odpov dola :
    //Zobrazen pijatho paketu (adresa, sig, ack a data)
    leAdrR.Text := inttostr(Adr);
    leSigR.Text := inttostr(Sig);
    eAck.Text := inttostr(Inst_Ack);
    case Inst_Ack of //U nvratovho kdu Ack zobrazme popis
      0: eAck.Text := eAck.Text + ' - OK';
      $0C..$0F: eAck.Text := eAck.Text + ' - Samovoln vysln';
      else eAck.Text := eAck.Text + ' - Chyba';
    end;

    if chSpinRcvHex.Checked //Pokud je zakrtnuto zobrazen dat v hexa ...
      then  mSDRcv.Text := TextToHex(Data) //... zobrazen v hexa ...
      else  mSDRcv.Text := TextToPrintable(Data); //... jinak zobrazit tisknuteln znaky dat.

  end else ShowMessage('Spinel instrukce neuspla.'); //pokud nedola odpov
end;

end.
